//  $Id: ALU.v,v 1.1.1.1 2007/04/20 23:07:44 vickery Exp $
/*  MIPS ALU subset from Hennessy and Patterson.
 *  C. Vickery
 *
 *  $Log: ALU.v,v $
 *  Revision 1.1.1.1  2007/04/20 23:07:44  vickery
 *  Initial version
 *
 */

module ALU(Zero, Result, funct, A, B);
input[31:0]   A, B;
input[3:0]    funct;
output        Zero;
output[31:0]  Result;

wire          Zero;
reg[31:0]     Result;
wire[31:0]    Aprime, Bprime, SumDiff;

	//	Handle A_invert, B_negate, and Zero condition code.
  assign Aprime = funct[3] ? ~A : A;
  assign Bprime = funct[2] ? ~B : B;
  assign SumDiff  = Aprime + Bprime + funct[2];
  assign Zero = (Result == 31'h00000000);

	//	MUX to generate result
  always
  begin
    case (funct[1:0])
      2'b00: Result = Aprime & Bprime; 
      2'b01: Result = Aprime | Bprime;
      2'b10: Result = SumDiff;
      2'b11: Result = {31'h00000000,SumDiff[31]};
    endcase
  end
endmodule
