//  $Id: Register_File.v,v 1.1.1.1 2007/04/20 23:07:48 vickery Exp $
/*  Hennessy and Patterson MIPS subset: three-port register file.
 *  C. Vickery
 *  April, 2007
 *
 *  $Log: Register_File.v,v $
 *  Revision 1.1.1.1  2007/04/20 23:07:48  vickery
 *  Initial version
 *
 */

module Register_File( read_data_1,
                      read_data_2,
                      read_reg_1,
                      read_reg_2,
                      write_reg,
                      write_data,
                      RegWrite,
                      CPU_Clock);

input[4:0]    read_reg_1, read_reg_2, write_reg;
input[31:0]   write_data;
input         RegWrite, CPU_Clock;
output[31:0]  read_data_1, read_data_2;
wire[31:0]    read_data_1, read_data_2;

//  The Registers
reg[31:0]   registers[31:1];

assign read_data_1 = (read_reg_1 == 0) ? 0 : registers[read_reg_1];
assign read_data_2 = (read_reg_2 == 0) ? 0 : registers[read_reg_2];

  always @(posedge CPU_Clock)
  begin
    if (RegWrite && (write_reg != 5'b00000))
      registers[write_reg] <= write_data;
  end
endmodule

