//  $Id: sign_extend_1632.v,v 1.1.1.1 2007/04/20 23:07:48 vickery Exp $
/*  
 *  Generate immediate operand.
 *  If op_code is lui (0xF), operand is immediate field followed by 0x0000.
 *  If op_code is andi or ori (0xC/D), zero extend 16 bits to 32 bits.
 *  Otherwise, sign extend immediate field.
 *  C. Vickery
 *  April, 2007
 *
 *  $Log: sign_extend_1632.v,v $
 *  Revision 1.1.1.1  2007/04/20 23:07:48  vickery
 *  Initial version
 *
 */
module gen_immediate_operand(operand, immediate, op_code);
input   [5:0]   op_code;
input   [15:0]  immediate;
output  [31:0]  operand;
wire    [31:0]  operand;

  assign operand = 
    (op_code == 5'b01111 ) ? { immediate, 16'h0000 } :
    { (((op_code == 5'b0110X) || (immediate[15] == 0)) ? 16'h0000 : 16'hFFFF), immediate};

endmodule
