//  $Id: pc_mux.v,v 1.1.1.1 2007/04/20 23:07:48 vickery Exp $
/*  Select the next address to be loaded into the MIPS PC.
 *  C. Vickery
 *  April, 2007
 *
 *  $Log: pc_mux.v,v $
 *  Revision 1.1.1.1  2007/04/20 23:07:48  vickery
 *  Initial version
 *
 */
module pc_mux(pc_out, pc_plus4, branch_addr, jump_addr, do_branch, do_jump);

input[31:0]   pc_plus4, branch_addr, jump_addr;
input         do_branch, do_jump;
output[31:0]  pc_out;
wire[31:0]    pc_out;

  assign pc_out = do_branch ? branch_addr :
                  do_jump ? jump_addr : pc_plus4;

endmodule

